## sra-sdk 2.11.3+dfsg

=== test/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

by_default: runtests

TOP ?= $(abspath ..)
MODULE = test

include $(TOP)/build/Makefile.shell

include $(TOP)/build/Makefile.config

#-------------------------------------------------------------------------------
# default
#
SUBDIRS =    \
	kdbmeta            \
	kar             \
	kget            \
	copycat         \
	vdb-config      \
	vdb-validate      \
	vdb-dump        \
	driver-tool     \
	srapath           \
	prefetch        \
	dump-test       \
	sra-stat        \
	sra-sort        \
	sra-pileup      \
	fastq-loader    \
	vdb-copy        \
	vcf-loader      \
	scripts           \
	align-info      \
	align-cache     \
	read-filter-redact \
	make-read-filter

# under construction
#    ngs-pileup      \

# common targets for non-leaf Makefiles; must follow a definition of SUBDIRS
include $(TOP)/build/Makefile.targets

$(SUBDIRS):
	@ $(MAKE) -C $@

.PHONY: default $(SUBDIRS)

#   time of slowtests in linux release mode
# real    4m 0.076s      user    4m22.256s      sys     0m10.707s     sra-sort
# real    5m21.151s      user    5m59.396s      sys     0m39.296s     fastdump
# real    6m55.921s      user    6m28.035s      sys     6m58.052s     sra-pileup
# real  184m21.347s      user   42m19.318s      sys   259m56.028s     fuse

=== build/docker/Makefile ===
# Make file for building SRA Toolkit docker image

ifndef VERSION
$(error VERSION needs to be set, e.g. make VERSION=2.11.1 build)
endif

BRANCH?=${VERSION}rc

.DEFAULT: build
.PHONY: build push clean scan test

build:
	docker pull alpine:latest
	docker build --build-arg VDB_BRANCH=${BRANCH} -t ncbi/sra-tools:${VERSION} --no-cache -f Dockerfile.build-alpine .
	docker tag ncbi/sra-tools:${VERSION} ncbi/sra-tools:latest

test:
	docker run -it --rm ncbi/sra-tools:${VERSION} fastq-dump -X 5 -Z SRR000001

scan:
	docker scan --file Dockerfile.build-alpine ncbi/sra-tools:${VERSION}

push:
	docker push ncbi/sra-tools:${VERSION}
	docker push ncbi/sra-tools:latest

clean:
	docker image rm ncbi/sra-tools ncbi/sra-tools:${VERSION}

=== test/copycat/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/copycat

TEST_TOOLS = \

include $(TOP)/build/Makefile.env

DIRTOTEST ?= $(BINDIR)
TOOLTOTEST = $(DIRTOTEST)/copycat
ifneq ("$(wildcard $(TOOLTOTEST))","")
    BIN_EXISTS = 1
else
    BIN_EXISTS = 0
endif

$(TEST_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

.PHONY: $(TEST_TOOLS)

clean: stdclean

#-------------------------------------------------------------------------------
# scripted tests
#
ifeq (1,$(HAVE_MAGIC))
  ifeq (0,$(BIN_EXISTS))
runtests: no-test
  else
runtests: copy
  endif
else
runtests:
	@ echo "NOTE - copycat tests are skipped:"          \
		"copycat was not built"
	@ echo "because it requires our internal library 'libkff'" \
		"which requires 'libmagic' and its development headers."
endif

no-test:
	@ echo $(TOOLTOTEST) does not exist. Test skipped.

copy: 
	@ echo "Testing $(DIRTOTEST)/copycat"
	@ rm -rf actual
	@ $(DIRTOTEST)/copycat -h >/dev/null
	@ export PATH=$(DIRTOTEST):$(PATH); vdb-config | grep bin > /dev/null && \
	 copycat ./input/1.xml actual/ >/dev/null && diff ./input/1.xml actual/1.xml\
	    > /dev/null
	@ rm -rf actual

=== test/driver-tool/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/driver-tool

include $(TOP)/build/Makefile.env

ifeq (rel,$(BUILD))

# The tests use dry run modes that are only available in debug builds. Skipping in the release mode.
runtests:

else

runtests: \
	announce \
	built-in \
	bogus \
	container \
	good \
	vdbcache \
	split_3 \
	split_e \
	fasta_missing_param \
	fasta_default \
	fasta_0 \
	fasta_number \
	fasta_neg_number \
	NO_SDL \
	help_srapath \
	help_prefetch \
	help_fasterq-dump \
	help_fastq-dump \
	testing \
	no_fasta_env \
	fasta_env \
	no_fasta_er_env \
	fasta_er_env

endif

DIRTOTEST ?= $(BINDIR)
TMPDIR ?= /tmp
TEMPDIR ?= $(TMPDIR)

GOOD =\
	fastq-dump \
	fasterq-dump \
	sam-dump \
	sra-pileup \
	vdb-dump \
	prefetch \
	srapath

CONTAINER =\
	SRP000001 \
	SRX000001 \
	SRS000001 \
	SRA000001 \
	ERP000001 \
	DRX000001

good: $(GOOD)

container: $(CONTAINER)

announce:
	@echo Testing $(DIRTOTEST)

$(TEMPDIR)/tmp.mkfg:
	@ echo '/LIBS/GUID = "c1d99592-6ab7-41b2-bfd0-8aeba5ef8498"' >$@

$(TEMPDIR)/tmp2.mkfg:
	@ echo '/LIBS/GUID = "c1d99592-6ab7-41b2-bfd0-8aeba5ef8498"' >$@ ;\
	  echo '/repository/remote/disabled = "true"' >>$@

mkfg: $(TEMPDIR)/tmp.mkfg

mkfg2: $(TEMPDIR)/tmp2.mkfg

actual:
	@ mkdir actual

built-in:
	@echo "running built-in tests" ; \
	SRATOOLS_TESTING=1 \
	$(BINDIR)/sratools

$(GOOD): | actual mkfg
	@# SRATOOLS_TESTING=2 skip SDL, sub-tool invocation is simulated to always
	@# succeed, but everything up to the exec call is real
	@echo "testing expected output for dry run of" $@ ;\
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	PATH=$(DIRTOTEST):$$PATH \
	SRATOOLS_TESTING=2 \
	SRATOOLS_IMPERSONATE=$@ \
	$(BINDIR)/sratools SRR000001 ERR000001 DRR000001 2>actual/$@.stderr && \
	diff expected/$@.stderr actual/$@.stderr

NO_SDL: | actual mkfg2
	@# SRATOOLS_TESTING=5 and skip SDL via config, sub-tool invocation is
	@# simulated to always succeed, but everything up to the exec call is real
	@echo "testing expected output for dry run with no SDL" ;\
	NCBI_SETTINGS=$(TEMPDIR)/tmp2.mkfg \
	PATH=$(DIRTOTEST):$$PATH \
	SRATOOLS_TESTING=5 \
	SRATOOLS_IMPERSONATE=fastq-dump \
	$(BINDIR)/sratools SRR000001 2>actual/NO_SDL.stderr && \
	diff expected/NO_SDL.stderr actual/NO_SDL.stderr

bogus: | actual mkfg
	@echo "testing expected output for unknown tool" ;\
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	PATH=$(DIRTOTEST):$$PATH \
	SRATOOLS_IMPERSONATE=rcexplain \
	$(BINDIR)/sratools 2>actual/$@.stderr ; \
	diff expected/$@.stderr actual/$@.stderr

$(CONTAINER): | actual mkfg
	@echo "testing expected output for container" $@ ;\
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	PATH=$(DIRTOTEST):$$PATH \
	SRATOOLS_IMPERSONATE=fastq-dump \
	$(BINDIR)/sratools $@ 2>actual/$@.stderr ; \
	diff expected/$@.stderr actual/$@.stderr

testing: | actual mkfg
	@echo "testing expected output for testing modes with bad inputs" ;\
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	PATH=$(BINDIR):$$PATH \
	SRATOOLS_TESTING=2 \
	SRATOOLS_IMPERSONATE=prefetch \
	$(BINDIR)/sratools --perm foo.jwt --cart foo.cart --ngc foo.ngc DRX000001 2>actual/testing.stderr ; \
	diff expected/testing.stderr actual/testing.stderr || diff expected/testing-cloudy.stderr actual/testing.stderr

vdbcache: | actual mkfg
	@echo "testing expected output for run with vdbcache" ;\
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	PATH=$(DIRTOTEST):$$PATH \
	SRATOOLS_TESTING=5 \
	SRATOOLS_IMPERSONATE=vdb-dump \
	$(BINDIR)/sratools SRR390728 2>actual/$@.stderr ; \
	diff expected/$@.stderr actual/$@.stderr

split_3: | actual mkfg
	@echo "testing expected output for fastq-dump --split-3" ;\
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	PATH=$(DIRTOTEST):$$PATH \
	SRATOOLS_TESTING=2 \
	SRATOOLS_IMPERSONATE=fastq-dump \
	$(BINDIR)/sratools --split-3 SRR390728 2>actual/$@.stderr ; \
	diff expected/$@.stderr actual/$@.stderr

split_e: | actual mkfg
	@echo "testing expected output for fastq-dump --split-e (sic)" ;\
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	PATH=$(DIRTOTEST):$$PATH \
	SRATOOLS_TESTING=2 \
	SRATOOLS_IMPERSONATE=fastq-dump \
	$(BINDIR)/sratools --split-e SRR390728 2>actual/$@.stderr ; \
	diff expected/$@.stderr actual/$@.stderr

fasta_missing_param: | actual mkfg
	@echo "testing expected output for fastq-dump --fasta <run>" ;\
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	PATH=$(DIRTOTEST):$$PATH \
	SRATOOLS_TESTING=2 \
	SRATOOLS_IMPERSONATE=fastq-dump \
	$(BINDIR)/sratools --fasta SRR390728 2>actual/$@.stderr ; \
	diff expected/$@.stderr actual/$@.stderr

fasta_default: | actual mkfg
	@echo "testing expected output for fastq-dump --fasta default <run>" ;\
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	PATH=$(DIRTOTEST):$$PATH \
	SRATOOLS_TESTING=2 \
	SRATOOLS_IMPERSONATE=fastq-dump \
	$(BINDIR)/sratools --fasta default SRR390728 2>actual/$@.stderr ; \
	diff expected/$@.stderr actual/$@.stderr

fasta_0: | actual mkfg
	@echo "testing expected output for fastq-dump --fasta 0 <run>" ;\
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	PATH=$(DIRTOTEST):$$PATH \
	SRATOOLS_TESTING=2 \
	SRATOOLS_IMPERSONATE=fastq-dump \
	$(BINDIR)/sratools --fasta 0 SRR390728 2>actual/$@.stderr ; \
	diff expected/$@.stderr actual/$@.stderr

fasta_number: | actual mkfg
	@echo "testing expected output for fastq-dump --fasta <number> <run>" ;\
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	PATH=$(DIRTOTEST):$$PATH \
	SRATOOLS_TESTING=2 \
	SRATOOLS_IMPERSONATE=fastq-dump \
	$(BINDIR)/sratools --fasta 75 SRR390728 2>actual/$@.stderr ; \
	diff expected/$@.stderr actual/$@.stderr

fasta_neg_number: | actual mkfg
	@echo "testing expected output for fastq-dump --fasta -<number> <run>" ;\
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	PATH=$(DIRTOTEST):$$PATH \
	SRATOOLS_TESTING=2 \
	SRATOOLS_IMPERSONATE=fastq-dump \
	$(BINDIR)/sratools --fasta -75 SRR390728 2>actual/$@.stderr ; \
	diff expected/$@.stderr actual/$@.stderr

no_fasta_env: | actual mkfg
	@echo "testing expected environment variables for fastq-dump <run>" ;\
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	PATH=$(DIRTOTEST):$$PATH \
	SRATOOLS_TESTING=5 \
	SRATOOLS_IMPERSONATE=fastq-dump \
	$(BINDIR)/sratools SRR390728 2>actual/$@.stderr ; \
	diff expected/$@.stderr actual/$@.stderr

fasta_env: | actual mkfg
	@echo "testing expected environment variables for fastq-dump --fasta default <run>" ;\
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	PATH=$(DIRTOTEST):$$PATH \
	SRATOOLS_TESTING=5 \
	SRATOOLS_IMPERSONATE=fastq-dump \
	$(BINDIR)/sratools --fasta default SRR390728 2>actual/$@.stderr ; \
	diff expected/$@.stderr actual/$@.stderr

no_fasta_er_env: | actual mkfg
	@echo "testing expected environment variables for fasterq-dump <run>" ;\
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	PATH=$(DIRTOTEST):$$PATH \
	SRATOOLS_TESTING=5 \
	SRATOOLS_IMPERSONATE=fasterq-dump \
	$(BINDIR)/sratools SRR390728 2>actual/$@.stderr ; \
	diff expected/$@.stderr actual/$@.stderr

fasta_er_env: | actual mkfg
	@echo "testing expected environment variables for fasterq-dump --fasta <run>" ;\
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	PATH=$(DIRTOTEST):$$PATH \
	SRATOOLS_TESTING=5 \
	SRATOOLS_IMPERSONATE=fasterq-dump \
	$(BINDIR)/sratools --fasta SRR390728 2>actual/$@.stderr ; \
	diff expected/$@.stderr actual/$@.stderr

help_srapath: | actual
	@echo "testing expected output for srapath --help" ;\
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	PATH=$(DIRTOTEST):$$PATH \
	SRATOOLS_IMPERSONATE=srapath \
	$(BINDIR)/sratools --help | sed -e'/"srapath" version/ s/version.*/version <deleted>/' >actual/$@.stdout ; \
	diff expected/$@.stdout actual/$@.stdout

help_prefetch: | actual
	@echo "testing expected output for prefetch --help" ;\
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	PATH=$(DIRTOTEST):$$PATH \
	SRATOOLS_IMPERSONATE=prefetch \
	$(BINDIR)/sratools --help | sed -e'/"prefetch" version/ s/version.*/version <deleted>/' >actual/$@.stdout ; \
	diff expected/$@.stdout actual/$@.stdout

help_fasterq-dump: | actual
	@echo "testing expected output for fasterq-dump --help" ;\
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	PATH=$(DIRTOTEST):$$PATH \
	SRATOOLS_IMPERSONATE=fasterq-dump \
	$(BINDIR)/sratools --help | sed -e'/"fasterq-dump" version/ s/version.*/version <deleted>/' >actual/$@.stdout ; \
	diff expected/$@.stdout actual/$@.stdout

help_fastq-dump: | actual
	@echo "testing expected output for fastq-dump --help" ;\
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	PATH=$(DIRTOTEST):$$PATH \
	SRATOOLS_IMPERSONATE=fastq-dump \
	$(BINDIR)/sratools --help | sed -e'/"fastq-dump" version/ s/version.*/version <deleted>/' >actual/$@.stdout ; \
	diff expected/$@.stdout actual/$@.stdout

.PHONY: runtests bogus container good $(CONTAINER) $(GOOD)
.INTERMEDIATE: $(TEMPDIR)/tmp.mkfg $(TEMPDIR)/tmp2.mkfg

=== test/dump-test/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ==============================================================================

default: runtests

TOP ?= $(abspath ../..)

include $(TOP)/build/Makefile.env

runtests: check_fastq_dump_crash

check_fastq_dump_crash:
	@NCBI_SETTINGS=/ $(BINDIR)/fastq-dump -Z -split-3 ERR034677 SRR125365 > /dev/null 2>&1

=== test/fastdump/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/fastdump

TEST_TOOLS = 

include $(TOP)/build/Makefile.env

.PHONY: $(TEST_TOOLS)

slowtests: fastdump1 fastdump2

ACC = SRR341578
SCRATCH ?= /tmp/$(shell whoami)
THREADS = 4

fastdump1: prepare $(BINDIR)/fastdump $(BINDIR)/vdb-dump
	@ mkdir -p $(SCRATCH)
	@./test_no_1.sh $(ACC) $(SCRATCH)/ $(THREADS) $(BINDIR)

fastdump2: $(BINDIR)/fastdump $(BINDIR)/vdb-dump
	@ mkdir -p $(SCRATCH)
	@./test_no_2.sh $(ACC) $(SCRATCH)/ $(THREADS) $(BINDIR)

prepare:
	@ export BINDIR=$(BINDIR) ; export VDB_INCDIR=$(VDB_INCDIR) ; \
        ./copy-default-kfg.sh

=== test/fasterq-dump/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/fasterq-dump

TEST_TOOLS =

include $(TOP)/build/Makefile.env

runtests: result_code_with_and_without_arguments

result_code_with_and_without_arguments:
	@echo "testing if fasterq-dump returns zero if called with help..."
	@$(BINDIR)/fasterq-dump -h > /dev/null
	@echo "OK"	
	@echo "testing if fasterq-dump returns none-zero if called without parameters..."
	@! $(BINDIR)/fasterq-dump > /dev/null
	@echo "OK"

.PHONY: $(TEST_TOOLS) result_code_with_and_without_arguments

=== test/fastq-loader/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

#TODO: transfer slowtests/big_loads (see CVS)

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/fastq-loader

TEST_TOOLS = \
	test-id2name \
	wb-test-fastq \
	wb-test-fastq-parse \
	test-fastq-loader

VDB_CONFIG = $(SRCDIR)

include $(TOP)/build/Makefile.env

DIRTOTEST ?= $(BINDIR)

$(TEST_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

.PHONY: $(TEST_TOOLS)

clean: stdclean

#-------------------------------------------------------------------------------
# FASTQ parsing test
#
FASTQ_PARSE_SRC = \
	wb-test-fastq-parse

FASTQ_PARSE_OBJ = \
	$(addsuffix .$(OBJX),$(FASTQ_PARSE_SRC))

FASTQ_PARSE_LIB = \
	-skapp \
	-sktst \
	-sfastqloader \
	-sload \
	-sncbi-vdb \

$(TEST_BINDIR)/wb-test-fastq-parse: $(FASTQ_PARSE_OBJ)
	$(LP) --exe -o $@ $^ $(FASTQ_PARSE_LIB)

parse: wb-test-fastq-parse
	$(TEST_BINDIR)/wb-test-fastq-parse  2>&1

#-------------------------------------------------------------------------------
# id2name
#
ID2NAME_TEST_SRC = \
	test-id2name

ID2NAME_TEST_OBJ = \
	$(addsuffix .$(OBJX),$(ID2NAME_TEST_SRC))

ID2NAME_TEST_LIB = \
	-skapp \
	-sktst \
	-sfastqloader \
	-sncbi-vdb

$(TEST_BINDIR)/test-id2name: $(ID2NAME_TEST_OBJ)
	$(LP) --exe -o $@ $^ $(ID2NAME_TEST_LIB)

id: test-id2name
	$(TEST_BINDIR)/test-id2name  2>&1

#-------------------------------------------------------------------------------
# white-box test
#
FASTQ_TEST_SRC = \
	wb-test-fastq

FASTQ_TEST_OBJ = \
	$(addsuffix .$(OBJX),$(FASTQ_TEST_SRC))

FASTQ_TEST_LIB = \
	-skapp \
	-sktst \
	-sfastqloader \
	-sload \
	-sncbi-wvdb \

$(TEST_BINDIR)/wb-test-fastq: $(FASTQ_TEST_OBJ)
	$(LP) --exe -o $@ $^ $(FASTQ_TEST_LIB)

wb: wb-test-fastq
	$(TEST_BINDIR)/wb-test-fastq  2>&1

#-------------------------------------------------------------------------------
# test-fastqtest-loader
#
FASTQTEST_LOADER_SRC = \
	test-fastq-loader

FASTQTEST_LOADER_OBJ = \
	$(addsuffix .$(OBJX),$(FASTQTEST_LOADER_SRC))

$(TEST_BINDIR)/test-fastq-loader: $(FASTQTEST_LOADER_OBJ)
	$(LP) --exe -o $@ $^ $(FASTQ_TEST_LIB)

tfl: test-fastq-loader
	$(TEST_BINDIR)/test-fastq-loader

.PHONY: test-fastq-loader

#-------------------------------------------------------------------------------
# scripted tests
#
runtests: announce wb parse set_schema smalltests

announce:
	@ echo Testing $(DIRTOTEST)

set_schema:
	echo "vdb/schema/paths = \"$(VDB_INCDIR)\"" > tmp.kfg
	echo "/LIBS/GUID = \"8test002-6ab7-41b2-bfd0-fastqloaderv\"" >> tmp.kfg

SMALLRUN = @ NCBI_SETTINGS= VDB_CONFIG=$(SRCDIR) $(SRCDIR)/runtestcase.sh \
        $(DIRTOTEST) $(SRCDIR)

smalltests: $(TEST_TOOLS)
	-rm -rf $(SRCDIR)/actual
#   Small tests
#   Input:
#       Quality encoding: phred/logodds, ascii/decimal
#           1.1 phred 33
	$(SMALLRUN) 1.1 0 $(SRCDIR)/input/1.1.fastq --quality PHRED_33
#           1.2 phred 64
	$(SMALLRUN) 1.2 0 $(SRCDIR)/input/1.2.fastq --quality PHRED_64
#           1.3 phred 33, decimal qualities
	$(SMALLRUN) 1.3 3 $(SRCDIR)/input/1.3.fastq --quality PHRED_33
#           1.4 logodds 64
	$(SMALLRUN) 1.4 0 $(SRCDIR)/input/1.4.fastq --quality LOGODDS
#
#       Single input file
#           2.1 reads only, basespace
	$(SMALLRUN) 2.1 0 $(SRCDIR)/input/2.1.fastq --quality PHRED_33
#           2.1.1 reads only, colorspace
#CS	$(SMALLRUN) 2.1.1 0 $(SRCDIR)/input/2.1.1.fastq --quality PHRED_33
#           2.2 qualities only
	@#-$(SMALLRUN) 2.2 0 $(SRCDIR)/input/2.2.fastq --quality PHRED_33
#           2.3 reads+qualities, qualities before reads
	@#-$(SMALLRUN) 2.3 0 $(SRCDIR)/input/2.3.fastq --quality PHRED_33
#           2.4 reads+qualities, reads before qualities
	@#-$(SMALLRUN) 2.4 0 $(SRCDIR)/input/2.4.fastq --quality PHRED_33
#           2.5 reads+qualities, paired up
	$(SMALLRUN) 2.5 0 $(SRCDIR)/input/2.5.fastq --quality PHRED_33
#           2.6 spot assembly
	$(SMALLRUN) 2.6 0 $(SRCDIR)/input/2.6.fastq --quality PHRED_33
#           2.7 spot assembly, read numbers not specified
	$(SMALLRUN) 2.7 0 $(SRCDIR)/input/2.7.fastq --quality PHRED_33
#           2.8 handling of N in reads, ALTREAD is a static column
#           TODO; investigate intermittent failure (FIXED_SPOT_LEN == 0, not 3)
	@#-$(SMALLRUN) 2.8 0 $(SRCDIR)/input/2.8.fastq --quality PHRED_33
#           2.8.1 handling of N in reads, ALTREAD is a physical column
	$(SMALLRUN) 2.8.1 0 $(SRCDIR)/input/2.8.1.fastq --quality PHRED_33
#           2.9 mismatching length of sequence and quality (qualities shorter)
	$(SMALLRUN) 2.9 3 $(SRCDIR)/input/2.9.fastq --quality PHRED_33
#           2.9.1 mismatching length of sequence and quality (qualities longer)
	$(SMALLRUN) 2.9.1 3 $(SRCDIR)/input/2.9.1.fastq --quality PHRED_33
#
#       Multiple files
#           3.1 reads+qualities together
	$(SMALLRUN) 3.1 0 $(SRCDIR)/input/3.1a.fastq $(SRCDIR)/input/3.1b.fastq --quality PHRED_33
#           3.2 qualities separately from reads, reads file comes first
	@#-$(SMALLRUN) 3.2 0 $(SRCDIR)/input/3.2a.fastq $(SRCDIR)/input/3.2b.fastq --quality PHRED_33
#           3.3 qualities separately from reads, qualities file comes first (reject?)
	@#-$(SMALLRUN) 3.3 0 $(SRCDIR)/input/3.3a.fastq $(SRCDIR)/input/3.3b.fastq --quality PHRED_33
#           3.4 default read number
#	$(SMALLRUN) 3.4 0 -r 1 $(SRCDIR)/input/3.4a.fastq -r 2 $(SRCDIR)/input/3.4b.fastq --quality PHRED_33
#
#   Command line options:
#           4.1 --tmpfs             temporary files created at the specified location
	@echo "running 4.1"; export NCBI_SETTINGS=/; export VDB_CONFIG=`pwd`; \
	 export LD_LIBRARY_PATH=$(LIBDIR);$(DIRTOTEST)/latf-load \
	 $(SRCDIR)/input/4.fastq --tmpfs $(SRCDIR)/actual/ -v \
	 -o actual/4.1.obj --quality PHRED_33 2>&1 \
	 | grep "Path for scratch files: $(SRCDIR)/actual/" >/dev/null
#           4.2 --qual-quant        quality values are quantized as specified
	$(SMALLRUN) 4.2 0 $(SRCDIR)/input/4.fastq --qual-quant 1:10,10:20,20:30,30:- --quality PHRED_33
#           4.3 --cache-size        handled correctly
	@echo "running 4.3"; export NCBI_SETTINGS=/; export VDB_CONFIG=`pwd`; \
	 export LD_LIBRARY_PATH=$(LIBDIR); \
	 $(DIRTOTEST)/latf-load $(SRCDIR)/input/4.fastq --cache-size 10 -v \
     -o actual/4.1.obj --quality PHRED_33 2>&1 \
     | grep "Cache size: 10M" >/dev/null
#           4.3.1 --cache-size      rejected if invalid
	$(SMALLRUN) 4.3.1 3 $(SRCDIR)/input/4.fastq --cache-size BIG --quality PHRED_33
#           4.4 --max-rec-count     stops at the specified record #
#CS	$(SMALLRUN) 4.4 0 $(SRCDIR)/input/4.4.fastq --max-rec-count 3 --quality PHRED_33
#           4.5 --max-err-count     stops after the specified # of errors
	$(SMALLRUN) 4.5 3 $(SRCDIR)/input/4.5.fastq --max-err-count 2 --quality PHRED_33
#           4.5.1 --max-err-pct     fails if % of error records is too high
#CS	$(SMALLRUN) 4.5.1 3 $(SRCDIR)/input/4.5.1.fastq --quality PHRED_33  --max-err-count 10 --max-err-pct 20
#           4.6 --platform          saves correct value in the PLATFORM column
	$(SMALLRUN) 4.6 0 $(SRCDIR)/input/4.fastq -p LS454 --quality PHRED_33
#           4.6.1 --platform        rejects invalid values
	$(SMALLRUN) 4.6.1 3 $(SRCDIR)/input/4.fastq -p SOMETHINGELSE --quality PHRED_33
#           4.7 input file missing
	$(SMALLRUN) 4.7 3 $(SRCDIR)/input/not_there --quality PHRED_33
#           4.8 drop read names
	$(SMALLRUN) 4.8 0 $(SRCDIR)/input/4.8.fastq --quality PHRED_33 --no-readnames
#   Gzipped input
	$(SMALLRUN) 5.0 0 $(SRCDIR)/input/5.0.fastq.gz --quality PHRED_33
#   Misparsed quality
	$(SMALLRUN) 6.0 0 $(SRCDIR)/input/6.0.fastq --quality PHRED_33
#   PACBIO fastq
	$(SMALLRUN) 7.1 0 $(SRCDIR)/input/7.1.fastq --platform=PACBIO --quality PHRED_33
	$(SMALLRUN) 7.2 0 $(SRCDIR)/input/7.2.fastq --platform=PACBIO --quality PHRED_33
	$(SMALLRUN) 7.3 0 $(SRCDIR)/input/7.3.fastq --platform=PACBIO --quality PHRED_33
#   secondary read numbers other than 3
	$(SMALLRUN) 8.0 0 $(SRCDIR)/input/8.0.fastq --quality PHRED_33
#   reject inconsistent secondary read numbers
	$(SMALLRUN) 8.1 3 $(SRCDIR)/input/8.1.fastq --quality PHRED_33
#   newest Illumina tag line variation ("_" instead of " /")
	$(SMALLRUN) 9.0 0 $(SRCDIR)/input/9.0.fastq --quality PHRED_33
#   accepting ascii quality values up to 126
	$(SMALLRUN) 10.0 0 $(SRCDIR)/input/10.0.fastq --quality PHRED_33
    # 2-file fasta, tag line Run.Spot.Read
	$(SMALLRUN) 11.0 0 $(SRCDIR)/input/11.0.1.fasta $(SRCDIR)/input/11.0.2.fasta --quality PHRED_33
    # 2-file fastq, tag line Run.Spot.Read
	$(SMALLRUN) 11.1 0 $(SRCDIR)/input/11.1.1.fastq $(SRCDIR)/input/11.1.2.fastq --quality PHRED_33
    # Illumina, ignore barcodes
	$(SMALLRUN) 12.0 0 $(SRCDIR)/input/12.0.fastq --quality PHRED_33 --ignore-illumina-tags
    # Illumina, use barcodes as spotgroups
	$(SMALLRUN) 12.1 0 $(SRCDIR)/input/12.1.fastq --quality PHRED_33
    # Illumina, use barcodes as spotgroups, alternative format
	$(SMALLRUN) 12.2 0 $(SRCDIR)/input/12.2.fastq --quality PHRED_33
    # Consume our own dog food (13.0.fastq created by fastq-dump )
	$(SMALLRUN) 13.0 0 $(SRCDIR)/input/13.0.fastq --quality PHRED_33
    # Consume our own dog food (13.1.fastq created by fastq-dump -F )
	$(SMALLRUN) 13.1 0 $(SRCDIR)/input/13.1.fastq --quality PHRED_33
    # SRA-2932: 30 is the preferred value for qualities when reading FASTA
	$(SMALLRUN) 14.0 0 $(SRCDIR)/input/14.0.fasta $(SRCDIR)/input/14.0.fasta --quality PHRED_33
    # VDB-3154: buffer insufficient
	$(SMALLRUN) 15.0 0 $(SRCDIR)/input/15.0.fastq --quality PHRED_33
    # VDB-3413: multi-line reads and qualities
	$(SMALLRUN) 16.0 0 $(SRCDIR)/input/16.0.fasta --quality PHRED_33 --platform=PACBIO
	$(SMALLRUN) 16.1 0 $(SRCDIR)/input/16.1.fastq --quality PHRED_33 --platform=PACBIO
	#
	#rm -rf $(SRCDIR)/actual

onetest:
	rm -rf $(SRCDIR)/actual
	$(SMALLRUN) 4.8 0 $(SRCDIR)/input/4.8.fastq --quality PHRED_33 --no-readnames

=== test/kdbmeta/Makefile ===
# ==============================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
# ==============================================================================

default: runtests

TOP ?= $(abspath ../..)
include $(TOP)/build/Makefile.env # BINDIR

DIRTOTEST ?= $(BINDIR)

runtests: test-kdbmeta

test-kdbmeta:
	@ NCBI_SETTINGS=/ $(DIRTOTEST)/kdbmeta SRR053325 > /dev/null

=== test/kget/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/kget

TEST_TOOLS = \

include $(TOP)/build/Makefile.env

CONFIGTOUSE ?= NCBI_SETTINGS
DIRTOTEST ?= $(BINDIR)
TOOLTOTEST = $(DIRTOTEST)/vdb-get
ifneq ("$(wildcard $(TOOLTOTEST))","")
    BIN_EXISTS = 1
else
    BIN_EXISTS = 0
endif

.PHONY: $(TEST_TOOLS)

announce:
	@ echo Testing $(DIRTOTEST) CONFIGTOUSE=$(CONFIGTOUSE)

#-------------------------------------------------------------------------------
# runtests: 
#
ifdef PYTHON
ifeq (0,$(BIN_EXISTS))
runtests: no-test
else
runtests: announce download
endif

else
runtests: ;

endif

no-test:
	@ echo $(TOOLTOTEST) does not exist. Test skipped.

download:
	@ PATH='$(DIRTOTEST):$(PATH)' VDB_CONFIG=`pwd` \
		NCBI_SETTINGS=../LIBS-GUID.mkfg NCBI_VDB_RELIABLE=y $(PYTHON) test_kget.py #expect rc=0

#-------------------------------------------------------------------------------
# slowtests: match output vs wget
#

slowtests: announce diff-vs-wget

ACCESSION = SRR072810
NAME = $(ACCESSION).wget
HOST = sra-download-internal.ncbi.nlm.nih.gov
URL=$(shell ${BINDIR}/srapath ${ACCESSION})

clean:
	rm -f $(ACCESSION)*

diff-vs-wget: clean
	@ if echo $(URL) | grep -vq /sdlr/sdlr.fcgi?jwt= ; \
	  then \
	     $(DIRTOTEST)/vdb-get --reliable -c ./$(ACCESSION).cachetee \
	                    $(URL) $(ACCESSION).dat --progress && \
	     wget --no-check-certificate $(URL) -O ./$(NAME) && \
	     diff ./$(NAME) ./$(ACCESSION).dat && \
	     rm -f $(ACCESSION)* ; \
	  else \
	     echo kget test when CE is required is skipped ; \
	  fi


.PHONY:

=== test/make-read-filter/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/make-read-filter

include $(TOP)/build/Makefile.env

TMPDIR ?= /tmp
TEMPDIR ?= $(TMPDIR)

$(TEMPDIR)/tmp.mkfg:
	@ echo '/LIBS/GUID = "c1d99592-6ab7-41b2-bfd0-8aeba5ef8498"' >$@; \
	  echo '/sra/quality_type = "raw_scores"' >>$@

mkfg: $(TEMPDIR)/tmp.mkfg

exe: $(BINDIR)/make-read-filter $(BINDIR)/vdb-dump $(BINDIR)/kar

test-data.kar: generate-test-data.py | mkfg exe
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	VDB_LIBRARY_PATH=$(VDB_LIBDIR) \
	python3 $^ $(TEMPDIR)/test-data && \
	$(BINDIR)/kar -d $(TEMPDIR)/test-data -fc $@ && \
	rm -rf $(TEMPDIR)/test-data expected

runtests: test-data.kar | mkfg exe
	$(BINDIR)/kar -d $(TEMPDIR)/test-data -x test-data.kar && \
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	$(BINDIR)/make-read-filter --temp $(TEMPDIR) $(TEMPDIR)/test-data && \
	NCBI_SETTINGS=$(TEMPDIR)/tmp.mkfg \
	$(BINDIR)/vdb-dump $(TEMPDIR)/test-data >$(TEMPDIR)/actual && \
	$(BINDIR)/kdbmeta -u $(TEMPDIR)/test-data -T SEQUENCE STATS READ_FILTER_CHANGES >$(TEMPDIR)/actual.stats && \
	diff expected $(TEMPDIR)/actual && diff expected.stats $(TEMPDIR)/actual.stats && \
	rm -rf $(TEMPDIR)/test-data

.PHONY: runtests
.INTERMEDIATE: $(TEMPDIR)/tmp.mkfg

=== test/ngs-pileup/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)

MODULE = test/ngs-pileup

TEST_TOOLS = \
    test-ngs-pileup

include $(TOP)/build/Makefile.env

$(TEST_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

.PHONY: $(TEST_TOOLS)

clean: stdclean

#-------------------------------------------------------------------------------
# test-ngs-pileup
#
TEST_NGS_PILEUP_SRC = \
	test-ngs-pileup 

TEST_NGS_PILEUP_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_NGS_PILEUP_SRC))
    
TEST_NGS_PILEUP_LIB =   \
	-sngs-c++           \
	-sncbi-ngs-c++      \
	-sncbi-vdb-static   \
	-skapp              \
    -sktst              \

$(TEST_BINDIR)/test-ngs-pileup: $(TEST_NGS_PILEUP_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_NGS_PILEUP_LIB)

#-------------------------------------------------------------------------------
# slowtests: match output vs sra-pileup
#

slowtests: diff-vs-sra-pileup

diff-vs-sra-pileup:
	-@ ./runtestcase.sh $(BINDIR) $(SRCDIR) 1.0 SRR833251
	@ ./runtestcase.sh $(BINDIR) $(SRCDIR) 2.0 SRR1166393
	@ ./runtestcase.sh $(BINDIR) $(SRCDIR) 3.0 ERR334733                # ILLUMINA
	@ ./runtestcase.sh $(BINDIR) $(SRCDIR) 4.0 SRR1068006
	@ ./runtestcase.sh $(BINDIR) $(SRCDIR) 5.0 SRR619510                # ABSOLID REF_ROWS=36172
	-@ ./runtestcase.sh $(BINDIR) $(SRCDIR) 6.0 SRR1251988               # SEC_ROWS=198
	@ ./runtestcase.sh $(BINDIR) $(SRCDIR) 7.0 SRR1186012               # ION_TORRENT
	-@ ./runtestcase.sh $(BINDIR) $(SRCDIR) 8.1 SRR556739 -r chrY # COMPLETE_GENOMICS
	-@ ./runtestcase.sh $(BINDIR) $(SRCDIR) 8.2 SRR556739 -r chrM # COMPLETE_GENOMICS, circular reference
	@ ./runtestcase.sh $(BINDIR) $(SRCDIR) 9.0 SRR341578 -r NC_011752.1         #:19900-20022

onediff:
	@ ./runtestcase.sh $(BINDIR) $(SRCDIR) 9.1 SRR341578 -r NC_011752.1:19900-20022

#alignment selection:
#TODO: multiple references in one accession
#TODO: multiple accessions with overlapping alignments
#TODO: filter by reference (-r ref) using canonic name
#TODO: filter by reference (-r ref) using common name 
#TODO: filter by multiple references (-r ref1 -r ref2)
#TODO: filter by position on the reference (-r ref:from-to)
#TODO: filter by multiple positions on the same reference (-r ref:from1-to1 -r ref:from2-to2)
#TODO: primary alignment table only (-t p)
#TODO: secondary alignment table only (-t s)
#TODO: evidence  table only (-t e)
#TODO: include duplicates (-d 1)
#TODO: do not include duplicates (-d 0) NB: broken in sra-pileup
#TODO: minimum mapq value (-q min)

#output control:
#TODO: omit qualities (-n)

#output file control:
#TODO: redirect output to a file (-o)
#TODO: bzip2 output (--bzip2)
#TODO: gzip output (--gzip)

# hidden options:
#TODO: output alignment information (-i)
# any more?

#not sure if these are needed:
#  -p|--spotgroups <spotgroups-modes>  divide by spotgroups 
#  -e|--seqname                     use original seq-name 
#  --minmismatch                    min percent of mismatches used in function 
#                                   mismatch, default is 5% 
#  --merge-dist                     If adjacent slices are closer than this,  
#                                   they are merged and skiplist is created.  
#                                   a value of zero disables the feature, 
#                                   default is 10000 
#  --function ref                   list references 
#  --function ref-ex                list references coverage 
#  --function count                 sort pileup with counters 
#  --function stat                  strand/tlen statistic 
#  --function mismatch              only lines with mismatch 
#  --function index                 list deletion counts 
#  --function varcount              variation counters:  ref-name, ref-pos, 
#                                   ref-base, coverage,  mismatch A, mismatch C, 
#                                   mismatch G, mismatch T, deletes, inserts, ins 
#                                   after A, ins after C, ins after G, ins 
#                                   after T 
#  --function deletes               list deletions greater then 20 
#
#Grouping of accessions into artificial spotgroups:
#  sra-pileup SRRXXXXXX=a SRRYYYYYY=b SRRZZZZZZ=a



.PHONY: diff-vs-sra-pileup

=== debian/changelog ===
sra-sdk (2.11.3+dfsg-1ubuntu1) jammy; urgency=medium

  * Disable LTO, this causes a misbuild that makes fastq-dump segfault.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 05 Apr 2022 15:21:01 +0000

sra-sdk (2.11.3+dfsg-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Fix watchfile to detect new versions on github
  * New upstream version 2.11.2.
  * Standards-Version: 4.6.0 (routine-update)
  * Bump versioned Build-Depends: libngs-sdk-dev (>= 2.11.2)
  * Skip test that test needs a *lot* of memory
  * Link against libzstd.  (Closes: #997280.)

  [ Aaron M. Ucko ]
  * d/p/fix_libngs_linkage.patch (new): Substitute ngs-c++ library for
    absent ngs library.
  * debian/rules: Stop renaming kget (to avoid a file conflict, #851219)
    now that it's retired altogether.
  * d/p/allow_multi_help.patch (new): Tolerate redundant --help
    declarations within tools/driver-tool.
  * d/p/run_unversioned_tools.patch (new): Look for tools by their
    unversioned names, per Debian's simplified installation arrangement.
  * debian/tests: Switch to modern encryption/decryption setup.
    - run-unit-test: Replace protected repository configuration (no longer
      supported as of ncbi-vdb 2.11.0) by --ngc [...].ngc.
    - test-data.tar.gz: Replace dbGaP-0.enc_key by a copy of upstream's
      test/prefetch/data/prj_phs710EA_test.ngc.
  * debian/watch: Look for tags rather than releases, as GitHub currently
    lists none(!) of the latter.
  * New upstream version 2.11.3.

 -- Aaron M. Ucko <ucko@debian.org>  Mon, 25 Oct 2021 18:29:10 -0400

=== debian/control ===
Source: sra-sdk
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Charles Plessy <plessy@debian.org>,
           Andreas Tille <tille@debian.org>,
           Aaron M. Ucko <ucko@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               libngs-sdk-dev (>= 2.11.2),
               libncbi-vdb-dev (>= 2.10.6+dfsg-3~),
               libvdb-sqlite-dev,
               libfuse-dev,
               libhdf5-dev,
               libmagic-dev,
               libxml2-dev,
               libzstd-dev,
               python3
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/med-team/sra-sdk
Vcs-Git: https://salsa.debian.org/med-team/sra-sdk.git
Homepage: https://github.com/ncbi/sra-tools/
Rules-Requires-Root: no

Package: sra-toolkit
Architecture: amd64
Depends: ${shlibs:Depends},
         libncbi-wvdb2 (>= 2.10.6+dfsg-3~),
         ${misc:Depends}
Recommends: med-config
Description: utilities for the NCBI Sequence Read Archive
 Tools for reading the SRA archive, generally by converting individual runs
 into some commonly used format such as fastq.
 .
 The textual dumpers "sra-dump" and "vdb-dump" are provided in this
 release as an aid in visual inspection. It is likely that their
 actual output formatting will be changed in the near future to a
 stricter, more formalized representation[s]. PLEASE DO NOT RELY UPON
 THE OUTPUT FORMAT SEEN IN THIS RELEASE.
 .
 Other tools distributed in this package are:
  abi-dump, abi-load
  align-info
  bam-load
  cache-mgr
  cg-load
  copycat
  fasterq-dump
  fastq-dump, fastq-load
  helicos-load
  illumina-dump, illumina-load
  kar
  kdbmeta
  latf-load
  pacbio-load
  prefetch
  rcexplain
  remote-fuser
  sff-dump, sff-load
  sra-pileup, sra-sort, sra-stat, srapath
  srf-load
  test-sra
  vdb-config, vdb-copy, vdb-decrypt, vdb-encrypt, vdb-get, vdb-lock,
  vdb-passwd, vdb-unlock, vdb-validate
 .
 The "help" information will be improved in near future releases, and
 the tool options will become standardized across the set. More documentation
 will also be provided documentation on the NCBI web site.
 .
 Tool options may change in the next release. Version 1 tool options
 will remain supported wherever possible in order to preserve
 operation of any existing scripts.

=== debian/rules ===
#!/usr/bin/make -f

# Pregenerated with uuidgen -r
DEBIAN_GUID = 806b5c3b-0088-4732-8359-51630950d723

# +pie breaks the build
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto

pkg := sra-toolkit

export DEB_CFLAGS_MAINT_APPEND   = -I/usr/include/ncbi-vdb
export DEB_CXXFLAGS_MAINT_APPEND = -I/usr/include/ncbi-vdb
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --no-parallel

OUTDIR=$(CURDIR)/debian/tmp
MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

override_dh_auto_clean:
	-dh_auto_clean

override_dh_clean:
	dh_clean
	rm -f reconfigure build/ld.linux.exe_cmd.sh build/Makefile.config build/Makefile.config.linux.x86_64
	rm -rf test/*/actual test/*/tmp.kfg tools/kqsh/kqsh-sra.[ch]

override_dh_update_autotools_config:
	echo "do nothing"

override_dh_auto_configure:
	# output dir will be checked so create it before
	mkdir -p debian/tmp/usr/lib
	ln -s /usr/lib/$(MULTIARCH) debian/tmp/usr/lib
	#
        # that's no standard configure script lacking support of default options
	#
	# --with-debug sets some options that require header files like compiler.h which
	# is internal to ncbi-vcb and not installed into the package - so this option
	# should not be used.
	./configure --build=$(MULTIARCH) --prefix=$(CURDIR)/debian/tmp/usr --build-prefix=$(CURDIR)/debian/tmp/usr --with-ngs-sdk-prefix=/usr

override_dh_auto_build:
	export LD_LIBRARY_PATH="$$LD_LIBRARY_PATH:$(OUTDIR)/lib"; export OUTDIR=$(OUTDIR) ; make DEB_CFLAGS="$(CFLAGS)" DEB_CXXFLAGS="$(CXXFLAGS)" DEB_LDFLAGS="$(LDFLAGS)"

override_dh_auto_install:
	dh_auto_install -- KONFIG_DIR=$(CURDIR)/debian/sra-toolkit/etc/ncbi

override_dh_install:
	# upstream installs versioned *.a libs - we only want a single version
	ls -l debian/tmp/usr/bin
	cd debian/tmp/usr/bin && \
	for bin in *-orig.* ; do \
	    base=$${bin%-orig.*} && \
	    vbase=$$(readlink "$$(readlink $$base)") && \
	    vdriver=$$(readlink "$$vbase") && \
	    mv -v $$bin $$base-orig && \
	    ln -snfv $${vdriver%%.[0-9]*} $$vbase || exit $$? ; \
	done && \
	for bin in *[a-z] ; do \
	    bin2=$$(readlink $$bin) ; \
	    bin3=$$(readlink "$$bin2") ; \
	    case $$bin2 in \
	        $$bin.* ) rm -v $$bin2 && mv -v $$bin3 $$bin || exit $$? ;; \
	    esac ; \
	done
	dh_install
	# remove susipcious file which is not executable and conflicts with package magic
	rm -f debian/*/usr/bin/magic
	# Formally supply a standard installation ID to satisfy sratools
	echo '/LIBS/GUID = "$(DEBIAN_GUID)"' >debian/$(pkg)/etc/ncbi/debian.kfg

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test --no-parallel -- -k
endif

override_dh_prep:
	dh_prep -X debian/tmp
